;; MENU.ASM
;; Menu loader for atari 2600 cartridge
;; 
;; Based on "A text adventure game/engine for the Atari 2600"
;; 100% Freeware by Greg Troutman, 1997
;; Copy Instructions: fiendishly
;;
;;Source is compatible with v2.12 of DASM.
;;
;;The compiled image, as distributed by me, runs
;;fine on the STELLA and V2600 emulators for Linux,
;;as well as on a Supercharger-equipped 2600 via
;;Bob Colbert's MAKEWAV utility.  It plays much
;;better on TV than on an emulator...
;;------------------------------------------------
;; Modified: ZX 2014.06 (cartridge loader)
;; Modified into _LotR, FotR_ by Adam Thornton, 2002
;; additional fixes by Thomas Jentzsch, 2002
  
        processor 6502
        include vcs.h

NUMCHARS      equ 12    
STATE_INIT    equ 0
STATE_SPLASH  equ 1
STATE_INIGAME equ 2
STATE_SELGAME equ 3
STATE_RUNGAME equ 4

; BGCOLOR_NORM  equ $62
; FGCOLOR_NORM  equ $1E
; FGCOLOR_SEL   equ $23

BGCOLOR_NORM  equ $B2
FGCOLOR_NORM  equ $0F
FGCOLOR_SEL   equ $7A

MAXLINE_NUM   equ 14
MAXPAGE_NUM   equ 17

; Zero page addresses for our RAM variables
;-------------------------------------------
frame           equ $80
temp            equ $81
temp2           equ $82
grfxBuffer      equ $83             ; 24 bytes
scanSec         equ grfxBuffer + 24 ;  1 byte 
currentText     equ scanSec + 1     ;  2 bytes
frameWait       equ currentText + 2 ;  1 byte
EOTflag         equ frameWait  + 1    ;  1 byte
currentState    equ EOTflag + 1     ;  1 byte
currentPage     equ currentState + 1;  1 byte
currentPos      equ currentPage  + 1;  1 byte
romSelected     equ currentPos + 1  ;  1 byte
codeLoader      equ romSelected + 1 ; 12 bytes

printValue      equ codeLoader + 12 ; 1 byte
printBuffer     equ printValue + 1  ; 8 bytes ;

      include macros.h

;==============================================================
      org $F000

; address space resevered for the bank switching

        dc.b #0
        dc.b #1
        dc.b #2
        dc.b #3
        dc.b #4
        dc.b #5
        dc.b #6
        dc.b #7
        dc.b #8
        dc.b #9
        dc.b #10
        dc.b #11
        dc.b #12
        dc.b #13
        dc.b #14
        dc.b #15
        dc.b #16
        dc.b #17
        dc.b #18
        dc.b #19
        dc.b #20
        dc.b #21
        dc.b #22
        dc.b #23
        dc.b #24
        dc.b #25
        dc.b #26
        dc.b #27
        dc.b #28
        dc.b #29
        dc.b #30
        dc.b #31
        dc.b #32
        dc.b #33
        dc.b #34
        dc.b #35
        dc.b #36
        dc.b #37
        dc.b #38
        dc.b #39
        dc.b #40
        dc.b #41
        dc.b #42
        dc.b #43
        dc.b #44
        dc.b #45
        dc.b #46
        dc.b #47
        dc.b #48
        dc.b #49
        dc.b #50
        dc.b #51
        dc.b #52
        dc.b #53
        dc.b #54
        dc.b #55
        dc.b #56
        dc.b #57
        dc.b #58
        dc.b #59
        dc.b #60
        dc.b #61
        dc.b #62
        dc.b #63
        dc.b #64
        dc.b #65
        dc.b #66
        dc.b #67
        dc.b #68
        dc.b #69
        dc.b #70
        dc.b #71
        dc.b #72
        dc.b #73
        dc.b #74
        dc.b #75
        dc.b #76
        dc.b #77
        dc.b #78
        dc.b #79
        dc.b #80
        dc.b #81
        dc.b #82
        dc.b #83
        dc.b #84
        dc.b #85
        dc.b #86
        dc.b #87
        dc.b #88
        dc.b #89
        dc.b #90
        dc.b #91
        dc.b #92
        dc.b #93
        dc.b #94
        dc.b #95
        dc.b #96
        dc.b #97
        dc.b #98
        dc.b #99
        dc.b #100
        dc.b #101
        dc.b #102
        dc.b #103
        dc.b #104
        dc.b #105
        dc.b #106
        dc.b #107
        dc.b #108
        dc.b #109
        dc.b #110
        dc.b #111
        dc.b #112
        dc.b #113
        dc.b #114
        dc.b #115
        dc.b #116
        dc.b #117
        dc.b #118
        dc.b #119
        dc.b #120
        dc.b #121
        dc.b #122
        dc.b #123
        dc.b #124
        dc.b #125
        dc.b #126
        dc.b #127
        dc.b #128
        dc.b #129
        dc.b #130
        dc.b #131
        dc.b #132
        dc.b #133
        dc.b #134
        dc.b #135
        dc.b #136
        dc.b #137
        dc.b #138
        dc.b #139
        dc.b #140
        dc.b #141
        dc.b #142
        dc.b #143
        dc.b #144
        dc.b #145
        dc.b #146
        dc.b #147
        dc.b #148
        dc.b #149
        dc.b #150
        dc.b #151
        dc.b #152
        dc.b #153
        dc.b #154
        dc.b #155
        dc.b #156
        dc.b #157
        dc.b #158
        dc.b #159
        dc.b #160
        dc.b #161
        dc.b #162
        dc.b #163
        dc.b #164
        dc.b #165
        dc.b #166
        dc.b #167
        dc.b #168
        dc.b #169
        dc.b #170
        dc.b #171
        dc.b #172
        dc.b #173
        dc.b #174
        dc.b #175
        dc.b #176
        dc.b #177
        dc.b #178
        dc.b #179
        dc.b #180
        dc.b #181
        dc.b #182
        dc.b #183
        dc.b #184
        dc.b #185
        dc.b #186
        dc.b #187
        dc.b #188
        dc.b #189
        dc.b #190
        dc.b #191
        dc.b #192
        dc.b #193
        dc.b #194
        dc.b #195
        dc.b #196
        dc.b #197
        dc.b #198
        dc.b #199
        dc.b #200
        dc.b #201
        dc.b #202
        dc.b #203
        dc.b #204
        dc.b #205
        dc.b #206
        dc.b #207
        dc.b #208
        dc.b #209
        dc.b #210
        dc.b #211
        dc.b #212
        dc.b #213
        dc.b #214
        dc.b #215
        dc.b #216
        dc.b #217
        dc.b #218
        dc.b #219
        dc.b #220
        dc.b #221
        dc.b #222
        dc.b #223
        dc.b #224
        dc.b #225
        dc.b #226
        dc.b #227
        dc.b #228
        dc.b #229
        dc.b #230
        dc.b #231
        dc.b #232
        dc.b #233
        dc.b #234
        dc.b #235
        dc.b #236
        dc.b #237
        dc.b #238
        dc.b #239
        dc.b #240
        dc.b #241
        dc.b #242
        dc.b #243
        dc.b #244
        dc.b #245
        dc.b #246
        dc.b #247
        dc.b #248
        dc.b #249
        dc.b #250
        dc.b #251
        dc.b #252
        dc.b #253
        dc.b #254
        dc.b #255

;==============================================================
      org $F100

Start
;-----------
;Clear memory, locate character graphics positions and such,
;initialize key memory values, start MainLoop.
;-------------------------------------------------------------

;the usual mumbo jumbo
;---------------------
        sei
        cld
        ldx #$FF
        txs
        lda #0
clear
        sta 0,x
        dex
        bne clear

;use cycle counting to get the GRP registers configured and located
;in exactly the right spot
;--------------------------------------
        sta WSYNC       ;newline
        lda #$06        ;triple copy sprites, spaced wide
        sta NUSIZ0      ;for both player graphic registers
        sta NUSIZ1
        lda #$31        ;draw leftmost and rightmost 2 playfield bits: reflect
        sta PF0         ;this turns left/right edges black
        sta CTRLPF      ;this makes playfield reflective
        nop             ;wait 2 cycles, we need them get our RESP0/1 right
        sta VDELP0      ;turn on vertical delay for both players
        sta VDELP1
        sta RESP0       ;mark our left margin here in P0
        lda #$D0        ;setup to shift over 3 pixels to the right
        sta RESP1       ;set P1
        sta HMP0        ;prep P0 for his HMOVE
        lda #$C0        ;setup to shift P1 4 pixels to the right
        sta HMP1        ;prep P1 for his HMOVE
        sta WSYNC       ;newline
        sta HMOVE       ;anchor them down

;the entire font is limited to one page, so we can hard code that page
;value into the MSB position of our graphics buffer
;-----------------------------------------------------
        ldx #23         ;graphics buffer is 24 bytes
        lda #>_space    ;load up the page value for the font
grOff
        sta grfxBuffer,x        ;stuff it, won't ever change
        dex             ;back up two bytes
        dex
        bpl grOff       ;and loop

;----
;initialize menu etc ..
;---------------------------------------------------------------------------
MainInit
        lda #0
        sta frame

        lda #STATE_INIT
        sta currentState

MainLoop
;-----------------
;Everything is set up, so loop through the basic game routines endlessly,
;cutting out only when RESET is pressed.  One pass of this loop represents
;one display frame.
;-------------------------------------------------------------------------

; ZX      lda SWCHB       ;read switch settings
; ZX      and #%00000001  ;turn off everything but bit 0
; ZX      bne noReset     ;if it's bit 0 = zero, then reset has been pushed
; ZX      jmp Start       ;so start over
noReset
        jsr beforeVBlank;spare time during screen blank
        jsr Picture     ;draw one screen
        jsr OverScan    ;spare time during over scan

        jsr VSync       ;start vertical retrace
        inc frame       ;we count frames for alternating graphics displays

        jmp MainLoop    ;back to top

VSync
;-------------------
        lda #2          ;bit 1 needs to be 1 to start retrace
        sta VSYNC       ;start retrace
        sta WSYNC       ;wait a few lines
        sta WSYNC
        sta WSYNC
        lda #44         ;prepare timer to exit blank period
        sta TIM64T      ;turn it on
        sta WSYNC       ;wait one more
        sta VSYNC       ;done with retrace, write 0 to bit 1
        rts

beforeVBlank
        lda frame       ;get current frame counter
        and #7          ;eighth frame?
        jsr execFSM     ;every 8th frame worry about FSM
        rts
Picture
;----------------
;Here is where we step down the screen drawing everything
;--------------------------------------------------------
        lda     INTIM               ;           check timer for end of VBLANK period
        bne     Picture             ;           loop until it reaches 0
        sta     WSYNC               ;           newline
        sta     VBLANK              ;           end screen blank

        lda     #BGCOLOR_NORM       ;           set background
        sta     COLUBK              ;           write it
        lda     #FGCOLOR_NORM       ;           restore main text colors
        sta     COLUP0
        sta     COLUP1
        lda     #MAXLINE_NUM+1      ;           setup counter for rows of text (14 lines)
        sta     scanSec             ;           store in zero page memory variable
        ldx     #NUMCHARS*2-2
        stx     EOTflag

        ldy     #12-10              ;           setup loop to
topMargin
        dey
        sta     WSYNC               ;           draw 12 blank lines at top of screen
        bne     topMargin
                                    ;           Y is used to track progress through this screen's text
ScanLoop
;---------------------

        lda     #BGCOLOR_NORM
        sta     COLUBK
        lda     currentPos
        cmp     scanSec
        bne     fgNormal     
fgSelect
        lda     #FGCOLOR_SEL
        sta     COLUP0
        sta     COLUP1
        jmp     startLine
fgNormal
        lda     #FGCOLOR_NORM
        sta     COLUP0
        sta     COLUP1

startLine
        lda     #37                 ; 2         a variable amount of text will be processed, so stay
        sta     TIM8T               ; 4 =  6     in sync by timing out after finished

        ldx     EOTflag             ; 3
        bpl     .enterLoop          ; 2
        ldx     #NUMCHARS*2-2       ; 2         will load from right to left
        bpl     noEOT               ; 3 = 10

nextCol
        sta     grfxBuffer,x        ; 4         no, stuff this char into the buffer
        dex                         ; 2
        bmi     eol                 ; 2
        dex                         ; 2

.enterLoop:
        lda     (currentText),y     ; 5/6       indirect/indexed - pointer to a section of text
        iny                         ; 2         next char
        cmp     #$FE                ; 2         done with a line?
        bcc     nextCol             ; 2= 22    just keep going--a screen w/o 10 $FF's will screw this up

        bne     noEOT               ; 2        FF is EOL
        sta     EOTflag             ; 3
noEOT
        lda     #<_space            ; 2         from previous row/frame/etc.
blankLine                           ;           fill rest of text buffer with spaces
        sta     grfxBuffer,x        ; 4         grfxBuffer is our 24 byte, 16 bit list of chars
        dex                         ; 2
        dex                         ; 2
        bpl     blankLine           ; 2= 17/18 fill it
;total: <= 289
eol
        lda     INTIM               ; 4         we finished, but wait for timer
        bne     eol                 ; 2         by looping till zero
        sta     WSYNC               ; 3 =  9    end current line

        sty     temp2               ; 3         need to save Y
        jsr     println             ; 6 =  9    print this row via subroutine
        ldy     temp2               ; 3         restore Y
        dec     scanSec             ; 5         next row to print
        bne     ScanLoop            ; 2= 11    loop until all 10 rows of text have been displayed

        lda     #66-25              ;           need to time out on menu row load as well
        sta     TIM8T
 
        ldy     #0                  ;           Y now points at position in menu text
        ldx     #NUMCHARS*2-2       ;           back to leftmost char of grfxBuffer

;new code to allow to use the last line:

exitMenu
        lda     #<_space            ; 2         from previous row/frame/etc.
blankLine2
        sta     grfxBuffer,x        ;           no? stuff it
        dex
        dex
        bpl     blankLine2          ;           all done? yes? get out

endMenu
        lda     INTIM
        bne     endMenu             ;           just wait for timer to reach zero
        sta     WSYNC               ;           finish this lineL

        ldx     #6-1                ;           and draw some blank lines
bottom
        sta     WSYNC
        dex
        bpl     bottom
        lda     #2
        sta     VBLANK              ;           finished a screen, blank the beam
        rts                         ;           done

;-------------------
; Compute states of the FSM and corresponding actions
;-------------------
execFSM
        lda currentState
        cmp #STATE_SELGAME 
        beq selectGame
        cmp #STATE_SPLASH 
        beq splashScreen
        cmp #STATE_INIGAME 
        beq initSelGame
        cmp #STATE_RUNGAME 
        beq runGame 
        jmp initFSM

runGame
        lda #0
        sta currentPos

        jmp loadSelGame 

;
; Splash screen state
;
splashScreen
        dec frameWait
        lda frameWait
        bne endSplashScreen
        lda #STATE_RUNGAME
        sta currentState
endSplashScreen
        rts
;
; Initialize Game selection state
;
initSelGame

        lda #1
        sta currentPage
        lda #MAXLINE_NUM+1
        sta currentPos

        jsr selectEnd

        lda #STATE_SELGAME
        sta currentState
; ZX
        lda #50
        sta frameWait

        rts
;
; Game selection state
;
selectGame
	      lda INPT4
	      bmi selectMove
        jmp selFire
selectMove
        dec frameWait
        lda frameWait
        bne exitSelect

        lda #5
        sta frameWait

        lda SWCHA       ;read joystick port as above
        bpl selectRight
        asl
        bpl selectLeft
        asl
        bpl selectDown   
        asl
        bpl selectUp
        jmp exitSelect

selectRight
         jmp selRight
selectLeft
         jmp selLeft
selectUp
         jmp selUp
selectDown
         jmp selDown
exitSelect
        rts

;
; Initialize FSM state
;
initFSM
        lda #0
        sta currentPos

        lda #STATE_INIGAME
        sta currentState

        rts

;Routines to handle menu selection
;==================================

println
;-------------------------
;Most of this subroutine is ripped from Stellar Trak.  Feel free to add
;your own comments--it's pretty straightforward ;)  and very touchy.  Won't
;work if a page boundary appears at certain places, due to excruciating
;cycle dependency, so if modifying the source, you might need an ALIGN
;pseudo-op to correct flubbery text displays.  ALIGN 256 will always work,
;but maybe ALIGN 128, ALIGN 64, etc. will also work, and not waste as many
;bytes.
;---------------------------------------------------

        ldx     #4                      ; 2
        sta     WSYNC                   ; 3
pause                                   ;
        nop                             ; 2
        dex                             ; 2
        bne     pause                   ; 2
        lda     temp                    ; 3
        lda     temp                    ; 3 = 33
                                        ;
        sta     HMCLR                   ; 3
        ldx     #$80                    ; 2
        ldy     #6                      ; 2                 FONTHEIGHT
        lda     frame                   ; 3
        lsr                             ; 2
        bcc     oddFrame                ; 2= 14/15
        bcs     evenFrame               ; 3 = 17
                                        ;
print1                                  ;           @64
        lda     (grfxBuffer+$16),y          ; 5
        nop                             ; 2
        sta     HMOVE                   ; 3         @74
;-----------------------------------------------------------
        sta     GRP0                    ; 3
        lda     (grfxBuffer + $12),y     ; 5 =  8    @06

        sta     GRP1                    ; 3
        lda     (grfxBuffer + $E),y     ; 5
        sta     GRP0                    ; 3
        lda     (grfxBuffer + $A),y     ; 5
        stx     HMP0                    ; 3
        stx     HMP1                    ; 3
        sta     GRP1                    ; 3
        lda     (grfxBuffer + $6),y    ; 5
        sta     GRP0                    ; 3
        lda     (grfxBuffer + $2),y    ; 5
        sta     GRP1                    ; 3
        sta     GRP0                    ; 3 = 44
evenFrame                               ;           @50
        dey                             ; 2
        bmi     wrapEven                ; 2
        lda     (grfxBuffer + $14),y     ; 5
        nop
        sta     GRP0                    ; 3
        lda     (grfxBuffer + $10),y     ; 5
        nop
        sta.w   GRP1                    ; 4 = 25    @75
;-----------------------------------------------------------
        sta     HMOVE                   ; 3
        lda     (grfxBuffer + $c),y     ; 5
        nop
        sta     GRP0                    ; 3
        lda     (grfxBuffer + $4),y    ; 5
        nop
        sta     temp                    ; 3
        lda     (grfxBuffer + $8),y     ; 5
        nop
        sta     GRP1                    ; 3
        lda     temp                    ; 3
        sta     GRP0                    ; 3
        lda     (grfxBuffer + $0),y    ; 5
        nop
        sta     GRP1                    ; 3 = 49
                                        ;
oddFrame                                ;           @48
        sta     GRP0                    ; 3
        lda     #$00                    ; 2
        sta     HMP0                    ; 3
        sta     HMP1                    ; 3
        dey                             ; 2
        bpl     print1                  ; 2= 16

wrapOdd                                 ;
        sta     WSYNC                   ;
        jmp     print2                  ; 3
                                        ;
wrapEven                                ;
        stx     HMP0                    ; 3
        stx     HMP1                    ; 3
        sta     WSYNC                   ; 3
        sta     HMOVE                   ; 3

print2                                  ;
        lda     #$00                    ; 2
        sta     GRP0                    ; 3
        sta     GRP1                    ; 3
        sta     GRP0                    ; 3
        rts                             ; 6 = 20

;Include the font file
;-------------------------
        align 256
        include menu.fon ;just change the filename to use a different font...

OverScan
;-----------------
;Wait around for thiry lines
;---------------------------
        ldx #30-4
loop_os
        sta WSYNC
        dex
        bne loop_os
        rts

; Select Right : goto next page
selRight
        lda currentPage
        cmp #MAXPAGE_NUM
        beq selRightLastPage
        inc currentPage 
        jmp selRightEnd
selRightLastPage
        lda #1
        sta currentPage
selRightEnd
        lda #MAXLINE_NUM+1
        sta currentPos
        jmp selectEnd

; Select Left : goto previous page
selLeft
        lda currentPage
        cmp #1
        beq selLeftFirstPage
        dec currentPage
        jmp selLeftEnd
selLeftFirstPage
        lda #MAXPAGE_NUM
        sta currentPage
selLeftEnd
        lda #MAXLINE_NUM+1
        sta currentPos
        jmp selectEnd

; Select Down : goto next line
selDown
        lda currentPos
        cmp #1
        beq selDownLastLine
        dec currentPos
        jmp selDownEnd
selDownLastLine
        lda #MAXLINE_NUM+1
        sta currentPos
selDownEnd
        jmp selectEnd

; Select Up : goto previous line
selUp
        lda currentPos
        cmp #MAXLINE_NUM+1
        beq selUpFirstLine
        inc currentPos
        jmp selUpEnd
selUpFirstLine
        lda #1
        sta currentPos
selUpEnd 
        jmp selectEnd

selFire
        lda currentPage
        tax
        dex
        txa
        clc
        sta romSelected
        adc romSelected
        adc romSelected
        adc romSelected
        adc romSelected
        adc romSelected
        adc romSelected
        adc romSelected
        adc romSelected
        adc romSelected
        adc romSelected
        adc romSelected
        adc romSelected
        adc romSelected
        adc romSelected
        sta romSelected
        sec
        lda #MAXLINE_NUM+1
        sbc currentPos
        adc romSelected
        sta romSelected

        lda #$80
        sta frameWait

        lda #0
        sta currentPos

        lda #STATE_SPLASH
        sta currentState

        lda #<splash0   ;the title screen
        sta currentText
        lda #>splash0
        sta currentText + 1

        rts

; update currentText from currentPage
selectEnd
selectUpdate
        lda currentPage
        tax
        dex
        txa
        asl
        tay  
        lda gamepageList,y
        sta currentText
        iny
        lda gamepageList,y
        sta currentText + 1
        rts

;
; runGame state
;
loadSelGame 

;;;       lda romSelected
;;;       sta printValue
;;;       jsr printHexa

;         lda #<loader0   ;the loader screen
;         sta currentText
;         lda #>loader0
;         sta currentText + 1
;         rts


          ; put code to switch bank and reset, in ram
          ldx #$0

          lda #$ad          ; AD = lda (F0xx) where xx is the game selected
          sta codeLoader,x
          inx 
          lda romSelected
          sta codeLoader,x
          inx 
          lda #$F0
          sta codeLoader,x
          inx 

          lda #$6c          ; 6C = jmp (addr)
          sta codeLoader,x
          inx
          lda #<vectreset
          sta codeLoader,x
          inx
          lda #>vectreset
          sta codeLoader,x
          inx 
          ; execute codeLoader
          jmp codeLoader

;          rts

;-------------------------
; print hexadecimal value (debug)

;;;       printHexa
;;;               lda #<printBuffer
;;;               sta currentText
;;;               lda #>printBuffer
;;;               sta currentText+1
;;;
;;;               ldy #0
;;;
;;;               lda printValue
;;;               and #$f0
;;;               lsr
;;;               lsr
;;;               lsr
;;;               tax
;;;
;;;               lda tblcvthexa,x
;;;               sta printBuffer,y
;;;               iny
;;;               ; lda tblcvthexa+1,x
;;;               ; sta printBuffer,y
;;;               ; iny
;;;          
;;;               lda printValue
;;;               and #$0f
;;;               asl
;;;               tax
;;;
;;;               lda tblcvthexa,x
;;;               sta printBuffer,y
;;;               iny
;;;               ; lda tblcvthexa+1,x
;;;               ; sta printBuffer,y
;;;               ; iny
;;;
;;;               lda #$FE
;;;               sta printBuffer,y
;;;
;;;               rts


;-------------------------
; texts

splash0
  lineL  sp,C,A,R,T,R,I,D,G,E,0,0
  lineL  sp,two,five,five,sp,I,N,sp,one,0,0,0
  blank
  blank
  blank
  lineL   sp,sp,L,O,A,D,I,N,G,dot,dot,dot
  blank
  blank
  blank
  lineL  Z,X,dash,eight,one,sp,ampersand,sp,B,U,Z,Z
  lineL  V,E,R,S,I,O,N,sp,one,dot,one,sp,0,0,0,0
  lineL  sp,sp,two,zero,one,four,dash,zero,six,0,0,0
  EOT

;;;       ; for printHexa
;;;       loader0
;;;         blank
;;;         blank
;;;         lineL  sp,C,A,R,T,R,I,D,G,E,0,0
;;;         lineL  sp,sp,two,five,five,sp,I,N,sp,one,0,0
;;;         blank
;;;         lineL  L,O,A,D,I,N,G,sp,G,A,M,E
;;;         blank
;;;         lineL  Z,X,dash,eight,one,sp,ampersand,sp,B,U,Z,Z
;;;         blank
;;;         blank
;;;         blank
;;;         EOT
;;;       ; end of printHexa

gamepageList
  wordOff gamepage1
  wordOff gamepage2
  wordOff gamepage3
  wordOff gamepage4
  wordOff gamepage5
  wordOff gamepage6
  wordOff gamepage7
  wordOff gamepage8
  wordOff gamepage9
  wordOff gamepage10
  wordOff gamepage11
  wordOff gamepage12
  wordOff gamepage13
  wordOff gamepage14
  wordOff gamepage15
  wordOff gamepage16
  wordOff gamepage17

  align 256

gamelist0
  include menu.data

;;;       ; For printHexa
;;;       tblcvthexa
;;;          wordOff zero
;;;          wordOff one
;;;          wordOff two
;;;          wordOff three
;;;          wordOff four
;;;          wordOff five
;;;          wordOff six
;;;          wordOff seven
;;;          wordOff eight
;;;          wordOff nine
;;;          wordOff A
;;;          wordOff B
;;;          wordOff C
;;;          wordOff D
;;;          wordOff E
;;;          wordOff F
  


;;========================

        org $FFFC
vectreset
        dc.w Start
        dc.w Start
